local chatLogPath = "C:\\Users\\ksn85\\Documents\\GTA San Andreas User Files\\Evolve\\chatlog.txt"
local imgui = require 'imgui'
local encoding = require 'encoding'
local inicfg = require 'inicfg'
local keys = require 'rkeys'
local vk = require 'vkeys'

filename_ini = "Notepad.ini"

ini = {}
ini.settings = {
    Xsize = 700,
    Ysize = 500,
    Xpos = 700,
    Ypos = 500,
}

inicfg.load(ini, filename_ini)

encoding.default = 'CP1251'
u8 = encoding.UTF8

local windowstate = imgui.ImBool(false)

local jsonFilePathNames = getWorkingDirectory()..'\\config\\NotepadNames.lua'
local jsonNames = {}
local nameInput = imgui.ImBuffer('', 256)
local selectedFile = nil
local selectedFile1235545 = nil
local awdirqpweoiweoipqeiwiqoep = imgui.ImBuffer('', 131072)
local chatLogLastUpdateTime = os.clock()


local showChatLog = imgui.ImBool(false)
local chatLogContent = imgui.ImBuffer('', 262144)


local function filterChatLog(content)
    local lines = {}
    for line in content:gmatch("[^\r\n]+") do
        table.insert(lines, line)
    end
    --    
    local out = {}
    for i = #lines, 1, -1 do
        out[#out+1] = lines[i]
    end
    return table.concat(out, "\n")
end


function loadChatLog()
    if doesFileExist(chatLogPath) then
        local file = io.open(chatLogPath, "r")
        if file then
            local content = file:read("*a")
            file:close()
            local filteredContent = filterChatLog(content)
            chatLogContent.v = u8(filteredContent ~= "" and filteredContent or u8" chatlog.txt ")
        else
            chatLogContent.v = u8"   chatlog.txt"
        end
    else
        chatLogContent.v = u8(" chatlog.txt    :\n" .. chatLogPath)
    end
end

function imgui.OnDrawFrame()
    -- 1)    :   renderIsReady()    false   
    if imgui.renderIsReady and not imgui.renderIsReady() then
        return
    end

    -- 2)         
    if not jsonNames or type(jsonNames) ~= "table" then
        jsonNames = {}
    end

    -- 3)    (   ChatLog)
    local screenWidth, screenHeight = getScreenResolution()

    -- 4)       
    imgui.SetNextWindowSize(imgui.ImVec2(ini.settings.Xsize, ini.settings.Ysize), imgui.Cond.FirstUseEver)
    imgui.SetNextWindowPos( imgui.ImVec2(ini.settings.Xpos, ini.settings.Ypos), imgui.Cond.FirstUseEver)

    -- 5)    Notepad
    local visible = imgui.Begin("Notepad by Pauly_Galtieri for SFN", windowstate, imgui.WindowFlags.NoScrollbar)
    if not visible then
        --         ,    
        imgui.End()
        return
    end

    -- 6)   /  INI
    do
        local sz = imgui.GetWindowSize()
        ini.settings.Xsize, ini.settings.Ysize = sz.x, sz.y
        local pos = imgui.GetWindowPos()
        ini.settings.Xpos, ini.settings.Ypos = pos.x, pos.y
        inicfg.save(ini, filename_ini)
    end

    -- 7)   ChatLog
    imgui.SetCursorPos(imgui.ImVec2(5, 25))
    if imgui.Button("ChatLog", imgui.ImVec2(80, 20)) then
        showChatLog.v = not showChatLog.v
        if showChatLog.v then
            chatLogLastUpdateTime = os.clock()
            loadChatLog()
        end
    end

    -- 8)    
    imgui.BeginChild("LeftPane", imgui.ImVec2(ini.settings.Xsize/4, 0), false, imgui.WindowFlags.NoScrollbar)
        --   
        imgui.PushItemWidth(ini.settings.Xsize/4 - 40)
        imgui.InputText("##newnote", nameInput)
        imgui.PopItemWidth()
        imgui.SameLine()
        if imgui.Button("+", imgui.ImVec2(25,0)) then
            AddNote(nameInput.v)
            nameInput.v = ""
        end

        --  
        for i = #jsonNames, 1, -1 do
            local nm = jsonNames[i]
            local d  = jsonRead(nm)
            if doesFileExist(FilePath3323233(nm)) then
                if imgui.Button(nm, imgui.ImVec2(ini.settings.Xsize/4 - 40, 0)) then
                    selectedFile = tonumber(d.id)
                    awdirqpweoiweoipqeiwiqoep.v = d.text or ""
                end
                imgui.SameLine()
                if imgui.Button("-", imgui.ImVec2(25, 0)) then
                    os.remove(FilePath3323233(nm))
                    table.remove(jsonNames, i)
                    jsonSaveNames(jsonNames)
                    if selectedFile == tonumber(d.id) then selectedFile = nil end
                end
            end
        end
    imgui.EndChild()

    -- 9)   +   
    imgui.SameLine()
    imgui.VerticalSeparator()
    imgui.SameLine()
    imgui.BeginChild("RightPane", imgui.ImVec2(0,0), false, imgui.WindowFlags.NoScrollbar)
        if selectedFile then
            --     ID
            for _, nm in ipairs(jsonNames) do
                local d = jsonRead(nm)
                if tonumber(d.id) == selectedFile then
                    selectedFile1235545 = d
                    break
                end
            end
            if selectedFile1235545 then
                local paneSz = imgui.GetWindowSize()
                imgui.SetCursorPosY(35)
                imgui.InputTextMultiline("##editor"..selectedFile,
                                         awdirqpweoiweoipqeiwiqoep,
                                         imgui.ImVec2(paneSz.x-10, paneSz.y-50))
                imgui.SetCursorPos(imgui.ImVec2(paneSz.x-55, 5))
                if imgui.Button("Save##"..selectedFile, imgui.ImVec2(45,0)) then
                    selectedFile1235545.text = awdirqpweoiweoipqeiwiqoep.v
                    jsonSave(selectedFile1235545.filename, selectedFile1235545)
                end
            end
        end
    imgui.EndChild()

    -- 10)   
    imgui.End()

    -- 11)       ChatLog
    if showChatLog.v then
        imgui.SetNextWindowSize(imgui.ImVec2(600,400), imgui.Cond.FirstUseEver)
        imgui.SetNextWindowPos(imgui.ImVec2(screenWidth/2-300, screenHeight/2-200), imgui.Cond.FirstUseEver)

        local vis2 = imgui.Begin("ChatLog", showChatLog,
                                imgui.WindowFlags.NoResize + imgui.WindowFlags.NoScrollbar)
        if vis2 then
            -- 
            if os.clock() - chatLogLastUpdateTime >= 5 then
                loadChatLog()
                chatLogLastUpdateTime = os.clock()
            end
            if imgui.Button("Refresh", imgui.ImVec2(80,20)) then
                loadChatLog()
            end
            imgui.SameLine()
            if imgui.Button("Close", imgui.ImVec2(80,20)) then
                showChatLog.v = false
            end

            local ws = imgui.GetWindowSize()
            imgui.InputTextMultiline("##chatlog",
                                     chatLogContent,
                                     imgui.ImVec2(ws.x-15, ws.y-50),
                                     imgui.InputTextFlags.ReadOnly)
        end
        imgui.End()
    end
end


function main()
    repeat wait(0) until isSampAvailable()
    wait(250)
    
    --   config,   
    if not doesDirectoryExist(getWorkingDirectory().."\\config") then
        os.execute('mkdir "'..getWorkingDirectory()..'\\config"')
    end
    
    --  jsonNames
    jsonNames = {}
    
    --    
    if not doesFileExist(jsonFilePathNames) then
        jsonSaveNames({})  --     
    end
    
    --  
    local loadedNames = jsonReadNames()
    if type(loadedNames) == "table" then
        jsonNames = loadedNames
    else
        jsonNames = {}
    end
    
    msg(u8'loaded')
    apply_custom_style()
    sampRegisterChatCommand('note', imguistate)
    
    while true do
        wait(0)
        if isKeyJustPressed(0x78) then
            windowstate.v = not windowstate.v
            imgui.Process = windowstate.v
        end
        imgui.Process = windowstate.v
    end
end

function AddNote(filenamee23)
    local t = {text='', id=getId(), filename=filenamee23}
    jsonSave(filenamee23, t)
    table.insert(jsonNames, filenamee23)
    jsonSaveNames(jsonNames)
end

function imguistate()
   windowstate.v = not windowstate.v
   imgui.Process = windowstate.v
end

function msg(text1212121212122222)
   sampAddChatMessage('[Notepad] {95f7ed}' .. text1212121212122222, 0x77d6ed)
end

function jsonRead(filenamee)
    local file = io.open(FilePath3323233(filenamee), "r+")
    local jsonInString = file:read("*a")
    file:close()
    local jsonTable = decodeJson(jsonInString)
    jsonTable.filename = filenamee
    return jsonTable
end

function jsonSave(filenamee, t)
    file = io.open(FilePath3323233(filenamee), "w")
    file:write(encodeJson(t))
    file:flush()
    file:close()
end

function getId()
    local maxid = 0
    for i = #jsonNames, 1, -1 do
        local noteName = jsonNames[i]
        local noteData = jsonRead(noteName)
        if doesFileExist(FilePath3323233(noteName)) then
            if maxid <= tonumber(noteData.id) then
                maxid = tonumber(noteData.id) + 1
            end
        end
    end
    return maxid
end

function FilePath3323233(filename)
    local path = getWorkingDirectory()..'\\config\\Notepad_' .. filename .. '.lua'
    return path
end

function jsonReadNames()
    if not doesFileExist(jsonFilePathNames) then
        return {}  --   ,   
    end
    
    local file, err = io.open(jsonFilePathNames, "r")
    if not file then
        print("  : " .. tostring(err))
        return {}
    end
    
    local jsonInString = file:read("*a")
    file:close()
    
    if jsonInString == "" then
        return {}  --   ->   
    end
    
    local success, jsonTable = pcall(decodeJson, jsonInString)
    if not success then
        print("  JSON: " .. tostring(jsonTable))
        return {}
    end
    
    return jsonTable or {}  --   
end

function jsonSaveNames(t)
    file = io.open(jsonFilePathNames, "w")
    file:write(encodeJson(t))
    file:flush()
    file:close()
end

function imgui.VerticalSeparator()
    local p = imgui.GetCursorScreenPos()
    imgui.GetWindowDrawList():AddLine(
        imgui.ImVec2(p.x, p.y),
        imgui.ImVec2(p.x, p.y + imgui.GetContentRegionMax().y),
        imgui.GetColorU32(imgui.GetStyle().Colors[imgui.Col.Separator])
    )
end

function apply_custom_style()
    imgui.SwitchContext()
    local style = imgui.GetStyle()
    local colors = style.Colors
    local clr = imgui.Col
    local ImVec4 = imgui.ImVec4
    style.WindowPadding = imgui.ImVec2(9, 5)
    style.WindowRounding = 10
    style.ChildWindowRounding = 10
    style.FramePadding = imgui.ImVec2(5, 3)
    style.FrameRounding = 6.0
    style.ItemSpacing = imgui.ImVec2(9.0, 3.0)
    style.ItemInnerSpacing = imgui.ImVec2(9.0, 3.0)
    style.IndentSpacing = 21
    style.ScrollbarSize = 6.0
    style.ScrollbarRounding = 13
    style.GrabMinSize = 17.0
    style.GrabRounding = 16.0
    style.WindowTitleAlign = imgui.ImVec2(0.5, 0.5)
    style.ButtonTextAlign = imgui.ImVec2(0.5, 0.5)

    colors[clr.Text]                   = ImVec4(0.90, 0.90, 0.90, 1.00)
    colors[clr.TextDisabled]           = ImVec4(1.00, 1.00, 1.00, 1.00)
    colors[clr.WindowBg]               = ImVec4(0.00, 0.00, 0.00, 1.00)
    colors[clr.ChildWindowBg]          = ImVec4(0.00, 0.00, 0.00, 1.00)
    colors[clr.PopupBg]                = ImVec4(0.00, 0.00, 0.00, 1.00)
    colors[clr.Border]                 = ImVec4(0.82, 0.77, 0.78, 1.00)
    colors[clr.BorderShadow]           = ImVec4(0.35, 0.35, 0.35, 0.66)
    colors[clr.FrameBg]                = ImVec4(1.00, 1.00, 1.00, 0.28)
    colors[clr.FrameBgHovered]         = ImVec4(0.68, 0.68, 0.68, 0.67)
    colors[clr.FrameBgActive]          = ImVec4(0.79, 0.73, 0.73, 0.62)
    colors[clr.TitleBg]                = ImVec4(0.00, 0.00, 0.00, 1.00)
    colors[clr.TitleBgActive]          = ImVec4(0.46, 0.46, 0.46, 1.00)
    colors[clr.TitleBgCollapsed]       = ImVec4(0.00, 0.00, 0.00, 1.00)
    colors[clr.MenuBarBg]              = ImVec4(0.00, 0.00, 0.00, 0.80)
    colors[clr.ScrollbarBg]            = ImVec4(0.00, 0.00, 0.00, 0.60)
    colors[clr.ScrollbarGrab]          = ImVec4(1.00, 1.00, 1.00, 0.87)
    colors[clr.ScrollbarGrabHovered]   = ImVec4(1.00, 1.00, 1.00, 0.79)
    colors[clr.ScrollbarGrabActive]    = ImVec4(0.80, 0.50, 0.50, 0.40)
    colors[clr.ComboBg]                = ImVec4(0.24, 0.24, 0.24, 0.99)
    colors[clr.CheckMark]              = ImVec4(0.99, 0.99, 0.99, 0.52)
    colors[clr.SliderGrab]             = ImVec4(1.00, 1.00, 1.00, 0.42)
    colors[clr.SliderGrabActive]       = ImVec4(0.76, 0.76, 0.76, 1.00)
    colors[clr.Button]                 = ImVec4(0.51, 0.51, 0.51, 0.60)
    colors[clr.ButtonHovered]          = ImVec4(0.68, 0.68, 0.68, 1.00)
    colors[clr.ButtonActive]           = ImVec4(0.67, 0.67, 0.67, 1.00)
    colors[clr.Header]                 = ImVec4(0.72, 0.72, 0.72, 0.54)
    colors[clr.HeaderHovered]          = ImVec4(0.92, 0.92, 0.95, 0.77)
    colors[clr.HeaderActive]           = ImVec4(0.82, 0.82, 0.82, 0.80)
    colors[clr.Separator]              = ImVec4(0.73, 0.73, 0.73, 1.00)
    colors[clr.SeparatorHovered]       = ImVec4(0.81, 0.81, 0.81, 1.00)
    colors[clr.SeparatorActive]        = ImVec4(0.74, 0.74, 0.74, 1.00)
    colors[clr.ResizeGrip]             = ImVec4(0.80, 0.80, 0.80, 0.30)
    colors[clr.ResizeGripHovered]      = ImVec4(0.95, 0.95, 0.95, 0.60)
    colors[clr.ResizeGripActive]       = ImVec4(1.00, 1.00, 1.00, 0.90)
    colors[clr.CloseButton]            = ImVec4(0.45, 0.45, 0.45, 0.50)
    colors[clr.CloseButtonHovered]     = ImVec4(0.70, 0.70, 0.90, 0.60)
    colors[clr.CloseButtonActive]      = ImVec4(0.70, 0.70, 0.70, 1.00)
    colors[clr.PlotLines]              = ImVec4(1.00, 1.00, 1.00, 1.00)
    colors[clr.PlotLinesHovered]       = ImVec4(1.00, 1.00, 1.00, 1.00)
    colors[clr.PlotHistogram]          = ImVec4(1.00, 1.00, 1.00, 1.00)
    colors[clr.PlotHistogramHovered]   = ImVec4(1.00, 1.00, 1.00, 1.00)
    colors[clr.TextSelectedBg]         = ImVec4(1.00, 1.00, 1.00, 0.35)
    colors[clr.ModalWindowDarkening]   = ImVec4(0.88, 0.88, 0.88, 0.35)
end
